#include "any.h"

// A FAIRE: 
//   1. précondition à renforcer (mais doit être prouvable dans le main) !
//      postcondition et clause assigns à écrire !
//      => à prouver en utilisant le modèle "Reference Arguments"
//      (ajouter l'option "-wp-model Typed+ref" sur la ligne de commandes)
//   2. précondition à renforcer pour pouvoir prouver postcondition
//      sans utiliser le modèle "Reference Arguments".
/*@ requires 0 <= x ;
  @ assigns \nothing;
  @ ensures *r==x;
  @*/
void div(int x,int y, int* q, int* r) {
  int i=0;

  // TODO : enforce the "loop invariant" (cf. div0.c)
  /*@ loop invariant x<=x; 
    @ loop assigns i,x ;
    @ loop variant x; */
  while (y <= x) {
    i++;
    x-=y;
  }
  *q=i;
  *r=x;
}

int main() {
  int x=any(), y=any(), q, r;

  if (x < 0) x=0;
  if (y < 1) y=1;

  div(x,y,&q,&r);

  /*@ assert 0 <= r ; */
  /*@ assert r < y; */
  /*@ assert x==q*y+r; */

  return q;
}
